package com.hzya.frame.plugin.cbs8.service;

import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.cbs8.dto.req.AgentPayResultRequestDTO;
import com.hzya.frame.cbs8.dto.req.TransactionDetailReqDTO;
import com.hzya.frame.cbs8.dto.res.AgentPayResultResDTO;
import com.hzya.frame.cbs8.dto.res.PayResponseDTO;
import com.hzya.frame.cbs8.dto.res.TransactionDetailDTO;
import com.hzya.frame.seeyon.cbs8.entity.AgentPaymentDetailEntity;
import com.hzya.frame.seeyon.cbs8.entity.AgentPaymentEntity;
import com.hzya.frame.seeyon.cbs8.entity.CbsLogEntity;
import com.hzya.frame.seeyon.cbs8.entity.PaymentEntity;

import java.util.List;

/**
 * @Description
 * @Author xiangerlin
 * @Date 2024/6/17 08:46
 **/
public interface ICbsPluginService {

    /**
     * 支付申请
     * @param entity
     */
     void applyPay(PaymentEntity entity)throws Exception;

    /**
     * 保存支付申请日志
     * @param entity
     * @throws Exception
     */
     void savePayLog(PaymentEntity entity,PayResponseDTO payResponseDTO)throws Exception;

    /**
     * 查询支付申请的交易结果
     * @param cbsLogEntity
     * @throws Exception
     */
     void queryResult(CbsLogEntity cbsLogEntity)throws Exception;

    /**
     * 电子回单查询 并上传OA
     * @param requestJson
     * @throws Exception
     */
    void elecBillUpload(JSONObject requestJson)throws Exception;

    /**
     * 查询交易明细
     * transactionDetailReqDTO.currentPage 、 transactionDetailReqDTO.pageSize 必填
     * @param transactionDetailReqDTO
     */
    List<TransactionDetailDTO> queryTransactionDetail(TransactionDetailReqDTO transactionDetailReqDTO);

    /**
     * 代发代扣 支付申请
     * @param paymentEntity
     */
    void applyAgentPay(AgentPaymentEntity paymentEntity);

    /**
     * 代发代扣 结果详情查询
     * @param agentPayResultRequestDTO
     * @return
     */
    AgentPayResultResDTO agentPayResult(AgentPayResultRequestDTO agentPayResultRequestDTO);

    /**
     * 保存交易明细到OA底表
     * @param transactionDetailList
     */
    void saveTransactionDetail(List<TransactionDetailDTO> transactionDetailList);

}
